public class Controller implements ControllerInterface {

	private ModelInterface model;
	private ViewInterface view;
	private double timeFrame;
	private HorlogeInterface horloge;

	public Controller( ModelInterface model ,ViewInterface view ){
		this.model = model;
		this.view = view;
		view.register( model );
		this.timeFrame = 1/60.0;
		this.horloge = new Horloge();
	}

	public void wait( double deltaTime ){
		if( deltaTime <= this.timeFrame ){
			try {
				Thread.currentThread().sleep( (int) ((this.timeFrame - deltaTime) * 1000) );
			}catch( InterruptedException e ){
				e.printStackTrace();
			}
		}
	}

	public void run(){
		while( true ){
			double deltaTime =  horloge.obtenirDeltaTemps();
			
			this.wait( deltaTime );	

			this.view.update( deltaTime );
			this.model.update( deltaTime );
		}
	}
}
