import java.util.concurrent.Semaphore;
import java.lang.Exception;


public class Model implements ModelInterface {
	private ViewInterface view;
	private Vecteur position;
	private Vecteur direction;
	private double vitesse;

	private final Semaphore available = new Semaphore(1);

	public Model(){
		this.position = new Vecteur();
		this.direction = new Vecteur(-1,-1);
		this.direction.normalize();
		this.vitesse = 0.5;
	}

	public void update( double deltaTime ){
		try {
			available.acquire();
			this.position.add( this.direction.mult(vitesse * deltaTime) );
			while( this.position.getX() > 1.0 ){
				this.position.setX(  this.position.getX() - 1.0 );
			}
			while( this.position.getX() < 0.0 ){
				this.position.setX(  this.position.getX() + 1.0 );
			}
			while( this.position.getY() > 1.0 ){
				this.position.setY(  this.position.getY() - 1.0 );
			}
			while( this.position.getY() < 0.0 ){
				this.position.setY(  this.position.getY() + 1.0 );
			}
			available.release();
		} catch( InterruptedException  e ){
			e.printStackTrace();
		}
	}

	public Vecteur getPosition(){
		Vecteur v = new Vecteur( this.position );
		try {
			available.acquire();
			v.set( this.position );
			available.release();
		} catch( InterruptedException e ){
			e.printStackTrace();
		}
		return v;
	}

	public void setDirection( Vecteur direction ){
		try {
			available.acquire();
			this.direction.set( direction );
			available.release();
		} catch( InterruptedException e ){
			e.printStackTrace();
		}
	}	

}
