import javax.swing.JFrame;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.BasicStroke;
import javax.swing.JPanel;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;



public class View extends JPanel implements ViewInterface,MouseListener {

	private JFrame fenetre;
	private ModelInterface model;

	private int width;
	private int height;

	private boolean stop;

	public View( int size ){
		this.fenetre = new JFrame();
		fenetre.setTitle("Demo");
		this.width = size;
		this.height = size;
		this.stop = false;
		fenetre.setSize(this.width, this.height);
		fenetre.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		fenetre.setContentPane(this);
		fenetre.setVisible(true);
		fenetre.addMouseListener( this );
	}

	public void paintComponent(Graphics g){
		//On décide d'une couleur de fond pour notre rectangle
		g.setColor(Color.white);
		//On dessine celui-ci afin qu'il prenne tout la surface
		g.fillRect(0, 0, this.getWidth(), this.getHeight());
		//On redéfinit une couleur pour notre rond
		g.setColor(Color.red);
		//On le dessine aux coordonnées souhaitées
		Vecteur v = model.getPosition();
		g.fillOval( (int)( v.getX() * this.width - 25 ) , (int)( v.getY()* this.height - 25 ) , 50, 50);
	}

	public void update( double deltaTime ){
	        this.repaint();
	}
	public void register( ModelInterface model ){
		this.model = model;
	}

	public void mouseClicked(MouseEvent e){
		Vecteur v = model.getPosition().mult( this.width, this.height );
		Vecteur userDirection = new Vecteur();
		userDirection.setX( e.getX() - v.getX() );
		userDirection.setY( e.getY() - v.getY() );
		userDirection.normalize();
		this.model.setDirection( userDirection );
	}

	public void mouseEntered(MouseEvent e){
	}

	public void mouseExited(MouseEvent e){
	}

	public void mousePressed(MouseEvent e){
	}

	public void mouseReleased(MouseEvent e){
	}

}
